Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Export TezosOfOCaml.Proto_alpha.Environment_modules.
Require Export Lia.

Module Notations.
  Export Compare.Notations.
  Export Int32.Notations.
  Export Int64.Notations.
  Export Option.Notations.
  Export Pervasives.Notations.
  Export Z.Notations.
End Notations.
Export Notations.

Ltac Zify.zify_pre_hook ::=
  autounfold with tezos_z in *;
  unfold
    Pervasives.normalize_int,
    Pervasives.normalize_int32,
    Pervasives.normalize_int64 in *;
  unfold
    Pervasives.two_pow_31,
    Pervasives.two_pow_32,
    Pervasives.two_pow_62,
    Pervasives.two_pow_63,
    Pervasives.two_pow_64 in *;

  simpl (Compare.Int.(Compare.S.op_eq) _ _) in *;
  simpl (Compare.Int.(Compare.S.op_ltgt) _ _) in *;
  simpl (Compare.Int.(Compare.S.op_lt) _ _) in *;
  simpl (Compare.Int.(Compare.S.op_gt) _ _) in *;
  simpl (Compare.Int.(Compare.S.op_lteq) _ _) in *;
  simpl (Compare.Int.(Compare.S.op_gteq) _ _) in *;
  simpl (Compare.Int.(Compare.S.compare) _ _) in *;
  simpl (Compare.Int.(Compare.S.max) _ _) in *;
  simpl (Compare.Int.(Compare.S.min) _ _) in *;
  simpl (Compare.Int.(Compare.S.equal) _ _) in *;

  simpl (_ =i32 _) in *;
  simpl (_ <>i32 _) in *;
  simpl (_ <=i32 _) in *;
  simpl (_ <i32 _) in *;
  simpl (_ >=i32 _) in *;
  simpl (_ >i32 _) in *;

  simpl (_ =i64 _) in *;
  simpl (_ <>i64 _) in *;
  simpl (_ <=i64 _) in *;
  simpl (_ <i64 _) in *;
  simpl (_ >=i64 _) in *;
  simpl (_ >i64 _) in *;

  simpl (_ =Z _) in *;
  simpl (_ <>Z _) in *;
  simpl (_ <=Z _) in *;
  simpl (_ <Z _) in *;
  simpl (_ >=Z _) in *;
  simpl (_ >Z _) in *;

  simpl (_ =s _) in *;
  simpl (_ <>s _) in *;
  simpl (_ <=s _) in *;
  simpl (_ <s _) in *;
  simpl (_ >=s _) in *;
  simpl (_ >s _) in *;

  autounfold with tezos_z in *;
  trivial.

(* This is needed for lia work with rem and mod
   https://coq.inria.fr/refman/addendum/micromega.html#coq:tacn.zify *)
Ltac Zify.zify_post_hook ::= Z.to_euclidean_division_equations.

From Hammer Require Export Tactics.
From RecordUpdate Require Export RecordSet.

Parameter set_record_field : forall {A B : Set}, A -> string -> B -> unit.

Parameter typ_with_with_non_trivial_matching : forall {A}, A.

(** ** Axioms and tactics about the existential casts generated by
       coq-of-ocaml. *)
Axiom cast_exists_eval_1 :
  forall {T : Set -> Set} {E1 : Set} {x : T E1},
  cast_exists T x = existT T E1 x.

Axiom cast_exists_eval_2 :
  forall {T : [Set ** Set] -> Set} {E1 E2 : Set} {x : T [E1, E2]},
  cast_exists T x = existT T [E1, E2] x.

Axiom cast_exists_eval_3 :
  forall {T : [Set ** Set ** Set] -> Set} {E1 E2 E3 : Set} {x : T [E1, E2, E3]},
  cast_exists T x = existT T [E1, E2, E3] x.

Axiom cast_exists_eval_4 :
  forall {T : [Set ** Set ** Set ** Set] -> Set} {E1 E2 E3 E4 : Set}
    {x : T [E1, E2, E3, E4]},
  cast_exists T x = existT T [E1, E2, E3, E4] x.

Axiom cast_exists_eval_5 :
  forall {T : [Set ** Set ** Set ** Set ** Set] -> Set} {E1 E2 E3 E4 E5 : Set}
    {x : T [E1, E2, E3, E4, E5]},
  cast_exists T x = existT T [E1, E2, E3, E4, E5] x.

Axiom cast_exists_eval_6 :
  forall {T : [Set ** Set ** Set ** Set ** Set ** Set] -> Set}
    {E1 E2 E3 E4 E5 E6 : Set} {x : T [E1, E2, E3, E4, E5, E6]},
  cast_exists T x = existT T [E1, E2, E3, E4, E5, E6] x.

Ltac rewrite_cast_exists :=
  match goal with
  | |- context[cast_exists (Es := ?Es) ?T ?x] =>
    match Es with
    | Set => rewrite (cast_exists_eval_1 (T := T) (x := x))
    | [Set ** Set] => rewrite (cast_exists_eval_2 (T := T) (x := x))
    | [Set ** Set ** Set] => rewrite (cast_exists_eval_3 (T := T) (x := x))
    | [Set ** Set ** Set ** Set] =>
      rewrite (cast_exists_eval_4 (T := T) (x := x))
    | [Set ** Set ** Set ** Set ** Set] =>
      rewrite (cast_exists_eval_4 (T := T) (x := x))
    | [Set ** Set ** Set ** Set ** Set ** Set] =>
      rewrite (cast_exists_eval_4 (T := T) (x := x))
    end
  end.

Definition bind_prop {a trace : Set}
  (x : Pervasives.result a trace) (f : a -> Prop) : Prop :=
  match x with
  | Pervasives.Ok x => f x
  | Pervasives.Error _ => True
  end.

Notation "'letP?' x ':=' X 'in' Y" :=
  (bind_prop X (fun x => Y))
  (at level 200, x name, X at level 100, Y at level 200).

Notation "'letP?' ' x ':=' X 'in' Y" :=
  (bind_prop X (fun x => Y))
  (at level 200, x pattern, X at level 100, Y at level 200).
